#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "gui_protocol.h"

Display *dis;
Window win,root,icon;
XSizeHints hints;
XWMHints wmhints;
int gravity;
int screen;
int borderwidth=1;
GC gc;
XClassHint classhint;
mldonkey_config config;
mldonkey_info info;
char ausgabe[10]="0";
char ausgabe2[10]="0";
float down;
float up;
int i;
int invert;

int main(int argc, char *argv[])
{

printf("\nWMMLDONKEY v0.002 extreeeeme buggy baby!!!\n\nUSAGE:\n-h [hostname]\n-p [port] \n-l [login]\n-pw [password]\n-i invert colors\n\n");

if(argc<=1) return(0);

config.mldonkey_hostname="127.0.0.1";
config.mldonkey_port=4001;
config.mldonkey_login=NULL;
config.mldonkey_password=NULL;
invert=0;

for(i=1;i<argc;i++)
{
if(!strcmp(argv[i],"-h")) config.mldonkey_hostname=argv[i+1];
if(!strcmp(argv[i],"-p")) config.mldonkey_port=atoi(argv[i+1]);
if(!strcmp(argv[i],"-l")) config.mldonkey_login=argv[i+1];
if(!strcmp(argv[i],"-pw")) config.mldonkey_password=argv[i+1];
if(!strcmp(argv[i],"-i")) invert=1;
}

dis=XOpenDisplay(NULL);
root=RootWindow(dis, screen);
XWMGeometry(dis, 1, NULL, NULL, 1, &hints, &hints.x, &hints.y, &hints.width, &hints.height, &gravity);
hints.flags=USSize|USPosition;
hints.x=0;
hints.y=0;
hints.height=56;
hints.width=56;
if(invert==1)
{
	win=XCreateSimpleWindow(dis, root, hints.x , hints.y, hints.height, hints.width, 0, BlackPixel(dis,0), BlackPixel(dis, 0));
	icon=XCreateSimpleWindow(dis, win, hints.x, hints.y, hints.width, hints.height, borderwidth, BlackPixel(dis, 0), BlackPixel(dis, 0));
}
else
{
	win=XCreateSimpleWindow(dis, root, hints.x, hints.y, hints.height, hints.width, 0, WhitePixel(dis,0), WhitePixel(dis,0));
	icon=XCreateSimpleWindow(dis, win, hints.x, hints.y, hints.width, hints.height, borderwidth, WhitePixel(dis,0), WhitePixel(dis, 0));
		
}
wmhints.initial_state=WithdrawnState;
wmhints.icon_window=icon;
wmhints.window_group=win;
wmhints.icon_x=hints.x;
wmhints.icon_y=hints.y;
wmhints.window_group=win;
wmhints.flags=StateHint|IconPositionHint|WindowGroupHint|IconWindowHint;

XSetClassHint(dis, win, &classhint);
XSetWMNormalHints(dis, win, &hints);
XSetWMHints(dis, win, &wmhints);
XSelectInput(dis, icon, StructureNotifyMask);
XMapWindow(dis, icon);
XMapWindow(dis, win);
gc=XCreateGC(dis, icon, 0, 0);

if(invert==1)
{
	XSetForeground(dis, gc, WhitePixel(dis, DefaultScreen(dis)));
}
else
{
	XSetForeground(dis, gc, BlackPixel(dis, DefaultScreen(dis)));
}

get_mldonkey_status(&config, &info);
mldonkey_info_message(&info);
sleep(5);
	
for(;;)
{
get_mldonkey_status(&config, &info);
mldonkey_info_message(&info);

down=(float)info.tcp_download_rate/1024;
up=(float)info.tcp_upload_rate/1024;

sprintf(ausgabe,"%.1fk", down);
sprintf(ausgabe2, "%.1fk", up);

XClearArea(dis, icon, 1, 1, 64, 64, 1);
XDrawString(dis, icon, gc, 3, 13, "download", 8);
XDrawString(dis, icon, gc, 3, 25, ausgabe, strlen(ausgabe));
XDrawString(dis, icon, gc, 3, 37, "upload", 6);
XDrawString(dis, icon, gc, 3, 49, ausgabe2, strlen(ausgabe2));
XFlush(dis);

sleep(1);
}
return(0);
}
